//    
//        
//      

    global _clear_nmc_fifos : label;
	global _clean_afifo: label;
	global _clean_wfifo: label;
    
begin text

//------------------------------------------
// clearFifos
//  afifo  wfifo

    <_clear_nmc_fifos>
    
        call _clean_afifo;
        call _clean_wfifo;
        return;
//------------------------------------------

.if (.nm64revision == 3) or (.nm64revision == 4);
 <_clean_afifo>
  pswr set   00004000h; //  AFCL   1
  pswr clear 00004000h; //  AFCL , afifo 
  return;
.endif; //.if (.nm64revision==3) or (.nm64revision==4);

.if (.nm64revision == 5);
  afifo_empty: label;
  fict: long;
 <_clean_afifo>
  push ar0,gr0;
  push ar1,gr1;
  .repeat 10;  //   ~10 cycles
    nul;       //    intr
  .endrepeat;  //
  gr0 = 00000400h; // intr[10]: AFIFO_VAL_EMPTA
  gr1 = intr;
  ar1 = fict with gr0 and gr1;
  if <>0 goto afifo_empty;

    rep 32 [ar1] = afifo;  //    
                           //   afifo,
                           //   rep 32 ...

 <afifo_empty>  // AFIFO_VAL_EMPTA==1
  pop ar1,gr1;
  pop ar0,gr0;
  return;
.endif;  //.if (.nm64revision == 5);

.if (.nm64revision == 3) or (.nm64revision == 4);
 <_clean_wfifo>
  pswr set   00008000h; //  WFCL   1
  pswr clear 00008000h; //  WFCL , wfifo 
  return;
.endif; //.if (.nm64revision==3) or (.nm64revision==4);

.if (.nm64revision == 5);
  wfifo_empty: label;
 <_clean_wfifo>
  push ar0,gr0;
  push ar1,gr1;
  .repeat 10;  //   ~10 cycles
    nul;       //    intr
  .endrepeat;  //
  wtw; //  ,   ftw   wtw
  gr0 = 00400000h; // intr[22]: WF_EMPTW
  gr1 = intr;
  with gr0 and gr1;
  if <>0 goto wfifo_empty;

  nb1 = 0;
  sb  = 0;
 <wfifo_nempty> // WF_EMPTW==0
  ftw,wtw;     //  wfifo  1 
  .repeat 10;  //   ~10 cycles
    nul;       //    intr
  .endrepeat;  //
  gr1 = intr;
  with gr0 and gr1;
  if =0 goto wfifo_nempty;

<wfifo_empty>  // WF_EMPTW==1
  pop ar1,gr1;
  pop ar0,gr0;
  return;
.endif;  //.if (.nm64revision == 5);


end text;


