//////////////////////////////////////////////////////////////////////////
//                                                                      //
//               NeuroMatrix(r) C runtime library                       //
//                                                                      //
//  memset.c                                                            //
//                                                                      //
// Copyright (c) 1997-2008 RC Module                                    //
//  If this code works, it was written by Alex Ruzavin                  //
//  If not, I don't know who wrote it.                                  //
//                                                                      //
// $Revision:: 2     $      $Date:: 2/01/08 1:56p    $                  //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include <string.h>

#ifdef __cplusplus
extern "C"
#endif  // __cplusplus

#if !defined(__NM6403__) && !defined(__NM6405__)
void * memset ( void *dest ,int val,size_t len )
{
  register unsigned char *ptr = (unsigned char*)dest;
  while (len-- > 0)
    *ptr++ = val;
  return dest;

#else		//	    ..

void * memset ( void * ,int ,size_t )
{
			//	
//	__asm{
//		push ar0,gr0;
//
//		ar5 = ar6 set;
//		ar0 = [ar5+=-5];	//	dest
//		gr7 = [--ar5];		//	val
//		gr0 = [--ar5] with gr7 = gr7 << 24;		//	len
//		ar5 = ar0 with gr0;
//		if =0 goto MEMS_L3 with gr7 = gr7 >> 24;
////9:      while (len-- > 0)
//		with gr0 = gr0 - 1;
//	<MEMS_L2>
//		if <>0 delayed goto MEMS_L2;
////10:       *ptr++ = val;
//		[ar0++] = gr7;
//		gr0 = gr0 - 1;
////11:     return dest;
//	<MEMS_L3>
//		pop ar0,gr0;
//		ar7 = ar6;
//		pop ar6,gr6;
//		return;
//	}
			//	,    
	__asm{
MEMS_reminder : label;
MEMS_main : label;

		push ar0,gr0;
		push ar1,gr1;

		ar5 = ar6 set;
		gr1 = [ar5+=-5];	//	dest
		gr0 = [--ar5];		//	val
		gr7 = [--ar5] with gr0 = gr0 << 24;		//	len

		ar5 = gr1 with gr7;
		ar1 = gr1;

		if =0 delayed goto MEMS_L3;
		with gr0 = gr0 >> 24;
		ar0 = gr0 with gr1 >>= 1;
		//--
		if not carry goto MEMS_dest_even;

		//--
			[ar1++] = gr0 with gr7-- noflags;		//	 destination 
	<MEMS_dest_even>
		gr6=gr7 with gr7 >>= 2;
		if not carry goto MEMS_half with gr7;
		[ar1++] = ar0,gr0;					//	   4+2  4+3
	<MEMS_half>
		if =0 goto MEMS_odd with gr7--;

	<MEMS_main>
		if <>0 delayed goto MEMS_main;
//10:       *ptr++ = val;
		[ar1++] = ar0,gr0 with gr7--;
		[ar1++] = ar0,gr0;
//--^
	<MEMS_odd>
		with gr6 >>=1;
		if not carry goto MEMS_L3;
		[ar1++] = ar0;						//	   2+1
//11:     return dest;
	<MEMS_L3>
		pop ar1,gr1;
		pop ar0,gr0;
		ar7 = ar6;
		pop ar6,gr6;
		return;
	}
  return 0;

#endif  // !defined(__NM6403__) && !defined(__NM6405__)
}
