/*
 *	Copyright (c) 1993-1996 by Research Computer Center (Expert Team)
 *	Moscow State University, Moscow, Russia
 *	All rights reserved.
 *
 *	%W%     %E%     (c) SRCC
 */

#define C_MALLOC

#include <stdlib.h>
#include <assert.h>

/*------------------------------------------------------\
|							|
|	default new [] operator				|
|							|
\------------------------------------------------------*/
typedef void (*PFVV)();

extern PFVV _new_handler;
extern void *_last_allocation;

void *
operator new[] (size_t size)
{
	void *p;

	if (size==0)
		size = 1;

	assert (int(size)>=0);

	while ((p = malloc(size)) == 0) {
		if (_new_handler != NULL)
			_new_handler();
		else
			return 0;
	}

	_last_allocation = p;

	return _last_allocation;
}
